#! /usr/bin/python
#-------------------------------------------------------------------------------
#
# Copyright 2015 Cumulus Networks, inc  all rights reserved
#
#-------------------------------------------------------------------------------
#

try:
    import json
except ImportError, e:
    raise ImportError (str(e) + "- required module not found")

# Netlink Manager IDs
CLAG_NLM_FDB_ID         = 3
CLAG_NLM_RECV_ID        = 4
CLAG_NLM_COLLECT_ID     = 5
CLAG_NLM_CHANGE_ID      = 6
CLAG_NLM_HELLO_TX_ID    = 7
CLAG_NLM_HELLO_RX_ID    = 8
CLAG_NLM_CMD_ID         = 9
CLAG_NLM_MAIN_ID        = 10
CLAG_NLM_LACP_ID        = 11
CLAG_NLM_RELOAD_ID      = 12
CLAG_NLM_VXLAN_PEER_ID  = 13
CLAG_NLM_VXLAN_CONFIG_ID= 14
CLAG_NLM_LACP_PEER_ID   = 15
CLAG_NLM_INIT_ID        = 16
CLAG_NLM_REMOTE_DELETE  = 17
CLAG_NLM_KERNEL_MSG     = 18

# qName: q
queueMap = {}

# qName: maxLen
queueMaxLens = {}

def queueSetMaxLen(qName):
    if qName in queueMap:
        qlen = queueMap[qName].qsize()
        if qlen > queueMaxLens.get(qName, 0):
            queueMaxLens[qName] = qlen

def queueAddNameMap(q, qName):
    queueMap[qName] = q

def queueGetInfo():
    qDb = {}
    for qName in queueMap:
        qInfo = {}
        qInfo['maxLen'] = queueMaxLens.get(qName, 0)
        qInfo['currLen'] = queueMap[qName].qsize()
        qDb[qName] = qInfo
    return json.dumps(qDb, sort_keys=True, indent=4)

